#include "bledevicediscovery.hpp"
#include <QtCore/QTimer>
#include <QtCore/QDebug>

static int exponent = 1;

BleDeviceDiscovery::BleDeviceDiscovery()
{   
  m_deviceDiscoveryAgent.setLowEnergyDiscoveryTimeout(800);

  connect(&m_deviceDiscoveryAgent, SIGNAL(deviceDiscovered(const QBluetoothDeviceInfo &)), this, SLOT(discoveredNewBLEDevice(const QBluetoothDeviceInfo &)));

//  connect(&m_deviceDiscoveryAgent, SIGNAL(deviceUpdated(const QBluetoothDeviceInfo &, QBluetoothDeviceInfo::Fields)), this,
//                                         SLOT(updateBLEdevice(const QBluetoothDeviceInfo &, QBluetoothDeviceInfo::Fields)));

  connect(&m_deviceDiscoveryAgent, SIGNAL(finished()), this,
                                         SLOT(finishedDiscovery()));

  //timer.connect(&timer, &QTimer::timeout, ([this](){ this->start();}));
  timer.connect(&timer, SIGNAL(timeout()), this, SLOT(start()));
  timer.setSingleShot(false);

  timer.start(2000);
  //m_deviceDiscoveryAgent.start();
}


void BleDeviceDiscovery::start()
{    
    timer.setInterval(exponent * 1000);
    qDebug()<<"Stopping discovery ...." <<m_deviceDiscoveryAgent.isActive();
    m_deviceDiscoveryAgent.stop();

    qDebug()<<"Starting discovery ....";
    m_deviceDiscoveryAgent.start(QBluetoothDeviceDiscoveryAgent::DiscoveryMethod::LowEnergyMethod);

    exponent++;

    if (exponent == 10)
    {
        exponent = 1;
    }

    qDebug()<<"***************Starting new discovery...****************************";
}

void BleDeviceDiscovery::finishedDiscovery()
{
    for(auto deviceInfo : m_deviceDiscoveryAgent.discoveredDevices())
    {
        if (deviceInfo.address().toString() == "C8:FD:19:3A:CD:87" && deviceInfo.rssi() != 0)
        {
            qDebug()<<"!!!!!!!!!!!!! Found temperature sensor... !!!!!!!!!!!! ";
        }

        if (deviceInfo.address().toString() == "C1:1B:42:D2:65:32")
        {
            qDebug()<<"----> In finished discovered device RSSI = "<<deviceInfo.rssi();

            if (deviceInfo.rssi() == 0)
            {
                m_toBeConnectedDevices.removeAll(deviceInfo.address().toString());
            }
            else
            {
                if (!m_toBeConnectedDevices.contains(deviceInfo.address().toString()))
                {
                    m_toBeConnectedDevices.append(deviceInfo.address().toString());
                    qDebug()<<"--> TO BE CONNECTED : "<<deviceInfo.address().toString();
                }
            }
        }
    }
}

void BleDeviceDiscovery::discoveredNewBLEDevice(const QBluetoothDeviceInfo & deviceInfo)
{
    //qDebug()<<"Device Info :"<<deviceInfo.address().toString();

    if (deviceInfo.address().toString() == "C1:1B:42:D2:65:32")
    {
        qDebug()<<"----> In new discovered device RSSI = "<<deviceInfo.rssi();
    }
}

//void BleDeviceDiscovery::updateBLEdevice(const QBluetoothDeviceInfo & deviceInfo, QBluetoothDeviceInfo::Fields)
//{
//    //qDebug()<<"---------> Updated Device Info :"<<deviceInfo.address().toString() <<" fields : ";

//    if (deviceInfo.address().toString() == "C1:1B:42:D2:65:32")
//    {
//        qDebug()<<"----> In update RSSI = "<<deviceInfo.rssi();
//    }
//}
